'' +--------------------------------------------------------------------------+
'' | CP/M 2.2 HDD & Directory Layout Information            CPMLAYOUT.spin    |
'' +--------------------------------------------------------------------------+
'' |  20July 2013 by "Cluso99" (Ray Rodrick)                                  |
'' +--------------------------------------------------------------------------+
'' No responsibility taken, but this is my belief based on actual work done.
'' The HDD DPB is taken from ZiCog (a CP/M & Z80 emulation for the P8X32A)
''-------------------------------------------------------------------------------------------------
''      CPM2.2 File System
''-------------------------------------------------------------------------------------------------
''      'ZiCog 8MB Hard Disk Parameter Blocks: 17 bytes CP/M + 2 bytes sector size used by SIMH hdsk_dpb
''      dpb_0                           '8MByte Default SIMH Altair HDSK params
''      :spt_low      BYTE      $20     'sectors per track (low byte)                   \ 32x 128byte sectors
''      :spt_high     BYTE      $00     'sectors per track (high byte)                  /
''      :bsh          BYTE      $05     'data allocation Block SHift factor               5=4KB  
''      :blm          BYTE      $1F     'data allocation block mask                       $1F+1=32*128=4KB
''      :exm          BYTE      $01     'EXtent Mask
''      :dsm_low      BYTE      $F9     'maximum data block number (low_byte)           \ $07F9+1= 2048-6 (8MB/4KB=2K -offset)
''      :dsm_high     BYTE      $07     'maximum data block number (high_byte)          /
''      :drm_low      BYTE      $FF     'total number of directory entries (low byte)   \ $03FF+1= 1024 entries of 32 bytes
''      :drm_high     BYTE      $03     'total number of directory entries (high byte)  /          
''      :al0          BYTE      $FF     'determine reserved directory blocks            \ $00FF+1= 256 blocks
''      :al1          BYTE      $00     'determine reserved directory blocks            /
''      :cks_low      BYTE      $00     'size of directory ChecK vector (low byte)      \ $0000 for fixed disk
''      :cks_high     BYTE      $00     'size of directory ChecK vector (high byte)     /
''      :off_low      BYTE      $06     'number of reserved tracks (offset) (low byte)  \ $0006 (6*32*128=6*4KB=24KB)
''      :off_high     BYTE      $00     'number of reserved tracks (offset) (high byte) /
''      :psh          BYTE      $00     'Physical record SHift factor, CP/M 3           \ $0000
''      :phm          BYTE      $00     'PHhysical record Mask, CP/M 3                  /
''      :ss_low       BYTE      $80     'Sector Size (low byte)                         \ $0080= 128 byte sectors
''      :ss_high      BYTE      $00     'Sector Size (high byte)                        /
''                                      'N.B. SS must be 128 for CP/M 2 can be varied for CP/M 3 hard disks.
''-------------------------------------------------------------------------------------------------
''      Directory Entries (32 bytes)
''-------------------------------------------------------------------------------------------------
''      UU  byte        'user number 0-15 or 0-31, $E5=unused/deleted
''      FN  byte[8]     'filename
''      TY  byte[3]     'filetype b7 of TY[0]=1=readonly, TY[1]=1=hidden
''      EX  byte        'extent counter  (see info below)
''      S1  byte        'reserved =0
''      S2  byte        'extent counter  (see info below)
''      RC  byte        'record counter  (see info below)
''      AL  word[8]     '8 allocation block locations (of 4KB for zicog 8MB HD)
''                      '  where the block no is calculated from the dir base
''                      '  therefore AL[n]=0 indicates not used, and the end of the allocation blocks
''      ------------------------------------------------------------------------
''  EX & S2:    Counts a sequence# of extents (i.e directory entries for this file)
''                EX[0] = 1 if there is another directory entry (extent) for this file.
''                Seq# = (S2[7..0] << 5) | (EXM[5..1] >> 1)
''  RC:         Counts the number of records (128 byte sectors) used in this extent (this directory entry)
''                RC=$80 if all 256 records are used (full extent)
''                Note: RC=$80 can also mean RC=128. This can be determined by AL[4] <> 0
''-------------------------------------------------------------------------------------------------
'' Here is an example of the directory entries for file BDOS.PRN 
'' UU ffffffffttt EX S1 S2 RC -AL0- -AL1- -AL2- -AL3- -AL4- -AL5- -AL6- -AL7- 
''---------------------------------------------------------------------------
'' 00 BDOS    PRN 01 00 00 80 40 00 41 00 42 00 46 00 47 00 48 00 49 00 4A 00
'' 00 BDOS    PRN 03 00 00 80 4B 00 4C 00 4D 00 4E 00 4F 00 50 00 51 00 52 00
'' 00 BDOS    PRN 05 00 00 80 53 00 54 00 55 00 56 00 57 00 58 00 59 00 5A 00
'' 00 BDOS    PRN 07 00 00 80 5B 00 5C 00 5D 00 5E 00 5F 00 60 00 61 00 62 00
'' 00 BDOS    PRN 09 00 00 80 63 00 64 00 65 00 66 00 67 00 68 00 69 00 80 00
'' 00 BDOS    PRN 0A 00 00 40 81 00 82 00 00 00 00 00 00 00 00 00 00 00 00 00
''-------------------------------------------------------------------------------------------------
